;+
;
; @file_comments
;
; @categories
;
; @param NAME
;
; @param DEBUT
;
; @param FIN
;
; @param NOMEXP
;
; @keyword PARENT {in}{required}
; The widget ID of the parent widget.
;
; @keyword BOXZOOM
; Vector indicating the geographic zone on which we want to cut the map.
; If BOXZOOM has :
;   1 element : The extraction is made on [lon1, lon2, lat1, lat2, 0.,boxzoom[0]]
;   2 elements: The extraction is made on [lon1, lon2, lat1, lat2, boxzoom[0],boxzoom[1]]
;   4 elements: The extraction is made on [Boxzoom, 0, max([gdept, gdepw])]
;   5 elements: The extraction is made on [Boxzoom[0:3], 0, Boxzoom[4]]
;   6 elements: The extraction is made on Boxzoom
; Where lon1, lon2,lat1,lat2 are global variables defined at the last domdef!
;
; @keyword _EXTRA
; Used to pass keywords
;
; @returns
;
; @uses
;
; @restrictions
;
; @examples
;
; @history
;
; @version
; $Id$
;
; @todo
; Seb: documenter
;
;-
;
FUNCTION slec,name,debut,fin, nomexp, PARENT = parent, BOXZOOM=boxzoom, _EXTRA = ex
;---------------------------------------------------------
;
  compile_opt idl2, strictarrsubs
;
@cm_4data
  IF NOT keyword_set(key_forgetold) THEN BEGIN
@updatenew
@updatekwd
  ENDIF
;------------------------------------------------------------
   case n_params() of
      1:tab = nlec(name, PARENT = parent, BOXZOOM=boxzoom, _EXTRA = ex)
      2:tab = nlec(name,debut, PARENT = parent, BOXZOOM=boxzoom, _EXTRA = ex)
      3:tab = nlec(name,debut,fin, PARENT = parent, BOXZOOM=boxzoom, _EXTRA = ex)
      4:tab = nlec(name,debut,fin, nomexp, PARENT = parent, BOXZOOM=boxzoom, _EXTRA = ex)
   endcase
;
   return, {tab:tab, grille:vargrid, unite:varunit, experience:varexp, nom:varname}
end
