;+
;
; @file_comments
;
; @categories
;
; @keyword JOUR
;
; @keyword MESHFILENAME
;
; @keyword LISTVAR
;
; @keyword LISTGRID
;
; @keyword FUNCLEC_NAME
;
; @keyword CALENDAR
;
; @keyword _EXTRA
; Used to pass keywords
;
; @uses
;
; @restrictions
;
; @examples
;
; @history
;
; @version
; $Id$
;
; @todo
; seb documenter
;
;-
;
PRO xx,  JOUR = jour, MESHFILENAME = meshfilename,  LISTVAR = listvar, LISTGRID = listgrid, FUNCLEC_NAME = funclec_name, CALENDAR = calendar, _extra = ex
;
  compile_opt idl2, strictarrsubs
;
@common
;----------------------------------------------------------------------
;----------------------------------------------------------------------
;  Name of the part to be changed
;----------------------------------------------------------------------
;----------------------------------------------------------------------
; Name of the reading function
   if NOT keyword_set(funclec_name) then funclec_name = 'slec'
   varexp = 'INF'
; list of variables
   if NOT keyword_set(listvar) then listvar = ['tn','sn','un','vn', 'taux', 'tauy','hdep20','hdep28','hdep15','hturb','hpycn','htoth','emp','qn','qs', 'smltot11', 'smltot12', 'smltot13', 'smltot14', 'smltot15', 'smltot16', 'tmltot11', 'tmltot12', 'tmltot13', 'tmltot14', 'tmltot15', 'tmltot16']
; list of grids to which variables refer to.
   if NOT keyword_set(listgrid) then BEGIN
      listgrid = replicate('T', n_elements(listvar))
      listgrid[[2, 4]] = 'U'
      listgrid[[3, 5]] = 'V'
   ENDIF
; calendar to be used (in IDL julian days
; ++++    if NOT keyword_set(calendar) then BEGIN
; ++++       if keyword_set(jour) then calendar = calendriertotem(/julian_day) ELSE calendar = calendriertotem(/julian_day, /mensuel)
; ++++    ENDIF
; Name of the file refering to the mask
   if NOT keyword_set(meshfilename) then meshfilename = '/usr1/com/smasson/IDL/INIT/inittotem.pro'
; ++++   meshparameters = whichgrid(meshfilename)
; parameters specifing how the field must be read
   readparameters= {funclec_name: funclec_name $
                    , jpidta: jpidta, jpjdta: jpjdta, jpkdta: jpkdta $
                    , ixmindta: ixmindta, ixmaxdta: ixmaxdta $
                    , iymindta: iymindta, iymaxdta: iymaxdta $
                    , izmindta: izmindta, izmaxdta: izmaxdta }
;----------------------------------------------------------------------
;----------------------------------------------------------------------
;   End of the part to be change
;----------------------------------------------------------------------
;----------------------------------------------------------------------
;
;
   fileparameters = {filename: 'many !' $
                     , time_counter: calendar $
                     , listvar: listvar $
                     , listgrid: strupcase(listgrid)}
;
   multistructure = {fileparameters: temporary(fileparameters) $
              , readparameters: temporary(readparameters) $
              , meshparameters: temporary(meshparameters)}
;
   xxx, multistructure = temporary(multistructure), _extra = ex

   return
end
